CFPRIME SATFU                                                           SATFU       1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
       SUBROUTINE SATFU(VM,V1,V2,G1,G2,FACT)                            SATFU       3
CD                                                                      SATFU       4
CD    TO CALCULATE MACHINE FULL SATURATION FACTORS.                     SATFU       5
CD                                                                      SATFU       6
       FACT=1.                                                          SATFU       7
       IF(VM.LE.V1)GOTO 2                                               SATFU       8
       A1=V1/VM                                                         SATFU       9
       A2=SQRT(1.-A1*A1)                                                SATFU      10
       F1=0.6366197*(1.-G1)*(ATAN2(A1,A2)+A1*A2)                        SATFU      11
       IF(VM.LE.V2)GOTO 1                                               SATFU      12
       A3=V2/VM                                                         SATFU      13
       A4=SQRT(1.-A3*A3)                                                SATFU      14
       F2=0.6366197*(G1-G2)*(ATAN2(A3,A4)+A3*A4)                        SATFU      15
       FACT=G2+F1+F2                                                    SATFU      16
       RETURN                                                           SATFU      17
  1    FACT=G1+F1                                                       SATFU      18
  2    RETURN                                                           SATFU      19
       END                                                              SATFU      20
C                                                                       SATFU      21
C                                                                       SATFU      22
       SUBROUTINE ISATFU(VM,V1,V2,G1,G2,FACT)                           SATFU      23
CD                                                                      SATFU      24
CD    TO CALCULATE MACHINE INCREMENTAL SATURATION FACTORS.              SATFU      25
CD                                                                      SATFU      26
       FACT=1.                                                          SATFU      27
       IF(VM.LE.V1)GOTO 2                                               SATFU      28
       A1=V1/VM                                                         SATFU      29
       A2=SQRT(1.-A1*A1)                                                SATFU      30
       F1=0.6366197*(1.-G1)*(ATAN2(A1,A2)-A1*A2)                        SATFU      31
       IF(VM.LE.V2)GOTO 1                                               SATFU      32
       A3=V2/VM                                                         SATFU      33
       A4=SQRT(1.-A3*A3)                                                SATFU      34
       F2=0.6366197*(G1-G2)*(ATAN2(A3,A4)-A3*A4)                        SATFU      35
       FACT=G2+F1+F2                                                    SATFU      36
       RETURN                                                           SATFU      37
  1    FACT=G1+F1                                                       SATFU      38
  2    RETURN                                                           SATFU      39
       END                                                              SATFU      40
                                                                        SATFU      41
